#!/bin/sh
# postinst script for wims-lti
#
# see: dh_installdeb(1)

set -e

# summary of how this script can be called:
#        * <postinst> `configure' <most-recently-configured-version>
#        * <old-postinst> `abort-upgrade' <new version>
#        * <conflictor's-postinst> `abort-remove' `in-favour' <package>
#          <new-version>
#        * <postinst> `abort-remove'
#        * <deconfigured's-postinst> `abort-deconfigure' `in-favour'
#          <failed-install-package> <version> `removing'
#          <conflicting-package> <version>
# for details, see https://www.debian.org/doc/debian-policy/ or
# the debian-policy package


# Source debconf library.
. /usr/share/debconf/confmodule

# db_get wims-lti/dbPassword || true
# dbPassword="$RET"

db_get wims-lti/adminEmail || true
adminEmail="$RET"

db_get wims-lti/adminPassword || true
adminPassword="$RET"

db_get wims-lti/virtualHost ||true
virtualHost="$RET"

db_get wims-lti/timeout ||true
timeout="$RET"

appDir=/var/lib/wims-lti
apacheConfDist=/etc/apache2/sites-available/wims-lti-django.conf-dist
apacheConf=/etc/apache2/sites-available/wims-lti-django.conf

case "$1" in
    configure)
	## create the user and the group "lti" when they do not exist
	if ! getent passwd lti; then
	    adduser --system --shell /bin/true --disabled-password \
		    --home /var/lib/wims-lti lti 
	fi
	if ! getent group lti; then
	    addgroup --system lti 
	fi
	## enable Apache's access
	setfacl -m u:lti:rwx /var/lib/wims-lti
	touch /var/lib/wims-lti/db.sqlite3
	setfacl -m u:lti:rw /var/lib/wims-lti/db.sqlite3
	## enabling the production settings
	[ ! -f $appDir/wimsLTI/settings-prod.py ] ||
	  cp $appDir/wimsLTI/settings-prod.py $appDir/wimsLTI/settings.py
	## recompile after the change in settings.py
	python3 -mpy_compile $appDir/wimsLTI/settings.py
	## create the file config.py if it does not exist
	## this must be done before the firts call to ./manage.py
	[ -f /var/lib/wims-lti/wimsLTI/config.py ] || \
	    cp /var/lib/wims-lti/wimsLTI/config.py_dpkg_dist \
	       /var/lib/wims-lti/wimsLTI/config.py
	## define ALLOWED_HOSTS in file config.py
	confFile=/var/lib/wims-lti/wimsLTI/config.py
	if ! grep -q "ALLOWED_HOSTS =.*$virtualHost" $confFile; then
	    sed -i 's/\(ALLOWED_HOSTS = \[\)\]/\1"'$virtualHost'",]/' $confFile
	fi
	sed -i 's/^WIMSAPI_TIMEOUT.*/WIMSAPI_TIMEOUT = '$timeout'/' $confFile
	## grab static files and migrate the database
	(cd $appDir; ./manage.py collectstatic --noinput; \
	 ./manage.py makemigrations; ./manage.py migrate)
	echo "database OK"
	## create the superuser
	adminOK=$(cd $appDir; sqlite3 -list db.sqlite3 "select count(*) from auth_user where is_superuser=1 and username='admin'")
	if [ "$adminOK" = 0 ]; then
	    cd $appDir; ./createsuperuser "admin" "$adminEmail" "$adminPassword" 2>&1 > /dev/null  ||true
	fi
	echo "superuser OK"
	## create the distribution's configuration for Apache
	## and copy it to Apache configuration if the file does not exist
	[ -f $apacheConf ] || \
	    sed "s/SERVERNAME/$virtualHost/" $apacheConfDist > $apacheConf
	## enable the website for wims-lti
	if ([ -f  /usr/sbin/a2ensite ]); then a2ensite wims-lti-django; fi
	## create the credentials file if it does not exist
	if [ ! -f $appDir/wims-lti/credentials ]; then
	    echo "Creation of the credentials in $appDir/wims-lti/credentials"
	    mkdir -p $appDir/wims-lti
	    echo "[DEFAULT]" > $appDir/wims-lti/credentials
	    db_get wims-lti/accessUser ||true
	    echo "  user = $RET" >> $appDir/wims-lti/credentials
	    db_get wims-lti/accessPassword ||true
	    echo "  password = $RET" >> $appDir/wims-lti/credentials
	    chown www-data:www-data $appDir/wims-lti/credentials
	    chmod 750 $appDir/wims-lti/credentials
	fi
	## apply any changes : restart WSGI services
	if [ -n "$(service apache2 status | grep active)" ]; then 
	    service apache2 reload
	fi
    ;;

    abort-upgrade|abort-remove|abort-deconfigure)
    ;;

    *)
        echo "postinst called with unknown argument \`$1'" >&2
        exit 1
    ;;
esac

# dh_installdeb will replace this with shell code automatically
# generated by other debhelper scripts.

#DEBHELPER#

exit 0
